package no.ntnu.idatt1002.demo.controller;

import java.io.IOException;

import java.net.URL;
import java.util.ResourceBundle;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.ComboBox;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.stage.Stage;
import no.ntnu.idatt1002.demo.data.Expense;
import no.ntnu.idatt1002.demo.data.ExpenseCategory;

public class SceneController implements Initializable {

    private Stage stage;
    private Scene scene;
    private Parent root;

    @FXML
    private Button add;

    @FXML
    private ComboBox<?> show;

    @FXML
    private TableColumn<Expense, Double> amount;

    @FXML
    private TableColumn<Expense, ExpenseCategory> category;

    @FXML
    private TableColumn<Expense, String> date;

    @FXML
    private TableColumn<Expense, String> description;

    @FXML
    private TableView<Expense> expenseTableView;

    ObservableList<Expense> expenses = FXCollections.observableArrayList(
        new Expense("", 1000.00, true, ExpenseCategory.FOOD, "1/1/23")
    );
    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {
        amount.setCellValueFactory(new PropertyValueFactory<Expense, Double>("amount"));
        category.setCellValueFactory(new PropertyValueFactory<Expense, ExpenseCategory>("category"));
        date.setCellValueFactory(new PropertyValueFactory<Expense, String>("date"));
        description.setCellValueFactory(new PropertyValueFactory<Expense, String>("description"));

        expenseTableView.setItems(expenses);
    }

    public void switchStartMenu(ActionEvent event) throws IOException {
        FXMLLoader loader = new FXMLLoader(getClass().getResource("/view/FirstMenu.fxml"));
        root = loader.load();
        stage = (Stage)((Node)event.getSource()).getScene().getWindow();
        scene = new Scene(root);
        stage.setScene(scene);
        stage.show();
    }
    public void switchNewBudget(ActionEvent event) throws IOException {
        FXMLLoader loader = new FXMLLoader(SceneController.class.getResource("/view/NewBudget.fxml"));
        Parent root = loader.load();
        stage = (Stage)((Node)event.getSource()).getScene().getWindow();
        scene = new Scene(root);
        stage.setScene(scene);
        stage.show();
    }

    public void switchExpenses(ActionEvent event) throws IOException {
        FXMLLoader loader = new FXMLLoader(SceneController.class.getResource("/view/Expenses.fxml"));
        Parent root = loader.load();
        stage = (Stage)((Node)event.getSource()).getScene().getWindow();
        scene = new Scene(root);
        stage.setScene(scene);
        stage.show();
    }

    public void addExpense(ActionEvent event) throws IOException {

    }
}